package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.UserRoleDataMapper;
import com.sa.ibiz.demo.demo.domain.UserRoleData;
import com.sa.ibiz.demo.demo.service.UserRoleDataService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.UserRoleDataSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.DataEntityService;
import com.sa.ibiz.demo.demo.service.OrgSectorService;
import com.sa.ibiz.demo.demo.service.OrgService;

/**
 * 实体[UserRoleData] 服务对象接口实现
 */
@Service
public class UserRoleDataServiceImpl extends ServiceImplBase<UserRoleDataMapper, UserRoleData> implements UserRoleDataService{

    @Autowired
    private DataEntityService deService;
    @Autowired
    private OrgSectorService dstorgsectorService;
    @Autowired
    private OrgService dstorgService;

    @Resource
    private UserRoleDataMapper userroledataMapper;


    @Override
    public boolean create(UserRoleData et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(UserRoleData et){
        this.beforeUpdate(et);
		this.userroledataMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(UserRoleData et){
		return et.getUserroledataid();  
    }

    @Override
    public boolean getDraft(UserRoleData et)  {
    if((!StringUtils.isEmpty(et.getDeid())) && et.getDe() == null){
            try {
                et.setDe(deService.getById(et.getDeid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getDstorgsectorid())) && et.getDstorgsector() == null){
            try {
                et.setDstorgsector(dstorgsectorService.getById(et.getDstorgsectorid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getDstorgid())) && et.getDstorg() == null){
            try {
                et.setDstorg(dstorgService.getById(et.getDstorgid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<UserRoleData> listDefault(UserRoleDataSearchFilter filter) {
		return userroledataMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<UserRoleData> searchDefault(UserRoleDataSearchFilter filter) {
		return userroledataMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return userroledataMapper.selectRow(sql);
    }

 }